<template>
  <CommandExecuteContext v-bind:commands="commandContext"></CommandExecuteContext>
</template>

<script>
  import ServerService from '@/domain/services/ServerService.js';
  import HelperUtil from '@/utils/HelperUtil'
  import UserCommands from "../../../commands/UserCommands"
  import CommandExecuteContext from '../../../commands/CommandExecuteContext'
  import UserService from '../../../domain/services/UserService.js'

  export default {
    props: ['command'],
    components: {
      CommandExecuteContext,
    },
    data:function () {
      return {
        deleteList: this.command.target,
        //命令
        commandContext: {},

        confirmFlag: {
          confirm: false,
        },
      }
    },
    methods: {
      close(){
        this.command.done()
      },
      open() {
        let _this = this;
        _this.InfoTip.conformTip(_this, HelperUtil.getCheckStatusCodeObjectByCode(_this.successCode.DELETE_CONFIRM)).then(() => {
          this.deleteServer();
        }).catch(()=>{
          this.close()
        });
      },

      //删除服务器
      deleteServer() {
        //调用函数
        let loadingInstance = this.Loading.openLoading();
        ServerService.deleteServers(JSON.stringify(this.deleteList)).then(result => {
          //成功
          this.Loading.closeLoading(loadingInstance);
          this.InfoTip.successTip(this, HelperUtil.getStatusCodeObjectByCode(this.successCode.DELETE_CODE))
          this.close()
        }).catch(err => {
          //失败
          this.Loading.closeLoading(loadingInstance);
          this.InfoTip.errorTip(this, err);
          this.close()
        })
      }
    },
    watch: {
      commandContext (newVal, oldVal){
        let _this = this;
        if(_this.confirmFlag.confirm){
          this.open();
          this.confirmFlag.confirm = false
        }
        else{
          if(JSON.stringify(newVal) === '{}'){
            _this.close()
          }
        }
        deep: true
      },
    },
    created() {
      this.confirmUserCommand.execute();
    },
    computed: {
      confirmUserCommand(){
        this.confirmFlag.confirm = false;
        return UserCommands.confirmUserCommand(this.commandContext, this.confirmFlag)
      },
    },
  }
</script>
